---
.docker-build-and-push-harbor:
  variables:
    IMAGE_NAME: "$INTERNAL_REGISTRY_URL/$CI_PROJECT_PATH"
    DOCKERFILE_NAME: "Dockerfile"
  tags:
    - $RUNNER_TAG
  rules:
    - if: $CI_COMMIT_REF_NAME == "main"
    - if: $CI_COMMIT_REF_NAME == "master"
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  script:
    - mkdir -p /kaniko/.docker
    - >-
      echo
      "{\"auths\":
      {\"${INTERNAL_REGISTRY_URL}\":
      {\"auth\":
      \"$(printf "%s:%s"
      "${INTERNAL_REGISTRY_USERNAME}"
      "${INTERNAL_REGISTRY_PASSWORD}"
      | base64 | tr -d '\n')\"}},
      \"index.docker.io\":
      {\"auth\":
      \"$(printf "%s:%s"
      "${DOCKERHUB_REGISTRY_USER}"
      "${DOCKERHUB_REGISTRY_TOKEN}"
      | base64 | tr -d '\n')\"}}
      }" > /kaniko/.docker/config.json
    - >-
      /kaniko/executor
      --skip-unused-stages=true
      --build-arg "http_proxy=${http_proxy}"
      --build-arg "HTTP_PROXY=${HTTP_PROXY}"
      --build-arg "https_proxy=${https_proxy}"
      --build-arg "HTTPS_PROXY=${HTTPS_PROXY}"
      --context "$CI_PROJECT_DIR"
      --dockerfile "$CI_PROJECT_DIR/$DOCKERFILE_NAME"
      --destination "$IMAGE_NAME"
      --destination "$IMAGE_NAME:$VERSION"
      --label org.opencontainers.image.authors="EMPAIA"
      --label org.opencontainers.image.vendor="EMPAIA"
      --label org.opencontainers.image.version="$VERSION"
      --label org.opencontainers.image.source=$CI_PROJECT_URL
      --label org.opencontainers.image.revision=$CI_COMMIT_SHA
      --label org.opencontainers.image.title="$TITLE"
      --label org.opencontainers.image.description="$DESCRIPTION"
